package org.nakedobjects.nof.util.memento;

import org.nakedobjects.noa.adapter.NakedObject;
import org.nakedobjects.nof.testsystem.TestProxySystem;

import junit.framework.TestCase;

import org.apache.log4j.Level;
import org.apache.log4j.Logger;


public class MementoTest extends TestCase {

    private NakedObject originalAdapter;
    private NakedObject returnedAdapter;

    protected void setUp() throws Exception {
        Logger.getRootLogger().setLevel(Level.OFF);

        TestProxySystem system = new TestProxySystem();
        system.init();

        originalAdapter = system.createAdapterForTransient(new TestPojoSimple("fred"));
        Memento memento = new Memento(originalAdapter);
        returnedAdapter = memento.recreateObject();
    }

    public void testDifferentAdapterReturned() throws Exception {
        assertNotSame(originalAdapter, returnedAdapter);
    }

    public void testHaveSameOid() throws Exception {
        assertEquals(originalAdapter.getOid(), returnedAdapter.getOid());
    }

    public void testHaveSameSpecification() throws Exception {
        assertEquals(originalAdapter.getSpecification(), returnedAdapter.getSpecification());
    }
    
    public void testName() throws Exception {
        TestPojoSimple originalPojo = (TestPojoSimple) originalAdapter.getObject();
        TestPojoSimple returnedPojo = (TestPojoSimple) returnedAdapter.getObject();
       
        // TODO need to add reflective code to test system for this to work
        // assertEquals(originalPojo.getName(), returnedPojo.getName());
    }
    
}

// Copyright (c) Naked Objects Group Ltd.
